import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

/**
 * Persists the counter value in the servlet into
 * the counter.data file.
 *
 * @author Daqing Hou
 */

public class CounterPersistence extends HttpServlet {


    public void doGet(HttpServletRequest request,
                      HttpServletResponse response)
        throws IOException, ServletException
    {
        response.setContentType("text/html");

        PrintWriter out = response.getWriter();
        out.println("<html>");
        out.println("<body>");
        out.println("<head>");

        out.println("<title> Counter  </title>");
        out.println("</head>");
        out.println("<body bgcolor=\"white\">");

        out.println("<h3> Counter = ");

        ServletContext context = getServletContext(); // ******     
        out.println(readCounter(context));
        out.println("</h3>");

        out.println("</body>");
        out.println("</html>");

        writeCounter(context);
    }

   private static void writeCounter(ServletContext context){
       String path = context.getRealPath("/") + "WEB-INF/classes/Counter.data";
       InMemoryCounter counter = (InMemoryCounter)context.getAttribute("counter");
       try {
       Writer writer = new FileWriter(path);
       writer.write(Integer.toString(counter.val()));
       writer.close();
       }
       catch (IOException ioe){
       }
   }

   private static int readCounter(ServletContext context){
        InMemoryCounter counter = null;
        try {
        counter = (InMemoryCounter)context.getAttribute("counter");
        }
        catch (ClassCastException cce){
        counter = null;
        }

        if (counter==null){
        String path = context.getRealPath("/") + "WEB-INF/classes/Counter.data";
        counter = new InMemoryCounter(path);
        context.setAttribute("counter", counter);
        }
        return counter.val();
   }
}
